#include "base.h"
#include <QDebug>
Category::Category(int id){
    job = NOTHING;
    category_id = id;
}
int Category::getCategoryId() const{
    return category_id;
}
void Category::setCategoryId(int id){
    category_id = id;
    for(int i = 0; i < questions.count();i++){
        ((Question*)&questions.at(i))->setCategoryId(id);
    }
}
void Category::addOneQuestion(Question q){
    this->questions.append(q);
    questions.last().setCategoryId(this->getCategoryId());
    questions.last().setParentAddress(this);
}

void Category::updateIds()
{
    for(int i = 0; i < questions.count();i++){
        Question* qq = (Question*)&questions.at(i);
        qq->setCategoryId(i);
        qq->updateIds();
    }
}
int Question::getQuestionid() const{
    return question_id;
}
int Question::getCategoryid() const{
    return category_id;
}
void Question::setQuestionId(int id){
    question_id = id;
    for(int i = 0; i < answers.count();i++){
        ((Answer*)&answers.at(i))->setQuestionId(id);
    }
}
Category* Question::getParent() const{
    return parentCategory;
}
void Question::setCategoryId(int cId){
    category_id = cId;
    for(int i = 0; i < answers.count();i++){
        ((Answer*)&answers.at(i))->setCategoryId(cId);
    }
}
void Question::setParentAddress (Category* c){
    parentCategory = c;
}
void Question::addOneAnswer(Answer a){
    answers.append(a);

    answers.last().setCategoryId(this->getCategoryid());
    answers.last().setQuestionId(this->getQuestionid());
}

void Question::updateIds()
{
    for(int i = 0; i < answers.count();i++){
        Answer* a = (Answer*)&answers.at(i);
        a->setQuestionId(this->getQuestionid());
        a->setCategoryId(this->getCategoryid());
    }
}
int Answer::getAnswer_id()  const {return answer_id;        }
int Answer::getQuestionId() const {return this->question_id;}
int Answer::getCategoryId() const {return this->category_id;}
bool Answer::isCorrect()    const {
    return this->isRight;
}
void Answer::setAnswerId  (int id){this->answer_id = id;  }
void Answer::setQuestionId(int id){this->question_id = id;}
void Answer::setCategoryId(int id){this->category_id = id;}
void Answer::setCorrect(bool b){
    isRight = b;
}
languageType::languageType(int id,QString langCode,QString langName){
    job = NOTHING;
    this->lang_Id   = id;
    this->lang      = langCode;

}
Question::Question(int id ,Category* parent){
    job = NOTHING;
    this->question_id = id;
    category_id = 0;
    this->parentCategory = parent;
}
int languageType::getLangId()  const{
    return this->lang_Id;
}
Answer::Answer(int answer_id, Question* parent){
    job = NOTHING;
    this->answer_id = answer_id;
    this->parentQuestion = parent;
}
Lang_Text::Lang_Text(int id, QString txt, job_state js){
    job = js;
    this->lang_id = id;
    this->text = txt;
}
void UserDataBase::printAll(){
    qDebug() << "print Deactivated!";
    return;
    qDebug() << "---------PRINT--------";
    for(int c = 0; c < categorys.count();c++){
        qDebug() << "CC";
        for(int l = 0; l < categorys.at(c).text.count();l++){

            qDebug() << "--" << categorys.at(c).text.at(l).text;
           // if(categorys.at(c).job == ADD_)qDebug() << "YALLA!";
        }
        for(int q = 0; q < categorys.at(c).questions.count();q++){
            qDebug() << "QQQQQ";
            for(int l = 0; l < categorys.at(c).questions.at(q).text.count();l++){
                qDebug() << ">---->" << categorys.at(c).questions.at(q).text.at(l).text;
            }
            for(int a = 0; a < categorys.at(c).questions.at(q).answers.count();a++){
                qDebug() << "!!!!!!!";
                for(int l = 0; l < categorys.at(c).questions.at(q).answers.at(a).text.count();l++){
                    qDebug() << ">>>>>>" << categorys.at(c).questions.at(q).answers.at(a).text.at(l).text;
                }
            }
        }
    }
    qDebug() << "---------END---PRINT--------";
}
void fixData(QList<Category>* cat,QList<languageType> languages){
    for(int c = 0; c < cat->count();c++){
        Category* cc = (Category*)&cat->at(c);
        cc->text = reOrderTextByLangId(&cc->text,languages);
        for(int q = 0; q < cc->questions.count();q++){
            Question* qq = (Question*)&cc->questions.at(q);


            qq->text = reOrderTextByLangId(&qq->text,languages);
            for(int a = 0; a < qq->answers.count();a++){
                Answer* aa = (Answer*)&qq->answers.at(a);
                aa->text = reOrderTextByLangId(&aa->text,languages);
            }
        }
    }
}
void setLangOfSingleElementTo(const Lang_Text* l,int lang_id,job_state j = IDK_){
    Lang_Text* ll = (Lang_Text*)l;
    ll->lang_id = lang_id;
    if(j != IDK_){
        ll->job = j;
    }
}
void checkStringForBadSymbols(const Lang_Text* l,int lang_id,job_state j = IDK_){
    Lang_Text* ll = (Lang_Text*)l;
    ll->lang_id = lang_id;
    if(j != IDK_){
        ll->job = j;
    }
}
void updateLangOfCategoryTo(QList<Category>* cat,int lang_id){
    for(int c = 0; c < cat->count();c++){
        Category* cc = (Category*)&cat->at(c);
        cc->job = ADD_;

        if(cc->text.count() > 0)setLangOfSingleElementTo(&cc->text.at(0),lang_id,ADD_);
        for(int q = 0; q < cc->questions.count();q++){
            Question* qq = (Question*)&cc->questions.at(q);
            qq->job = ADD_;
            if(qq->text.count() > 0)setLangOfSingleElementTo(&qq->text.at(0),lang_id,ADD_);
            for(int a = 0; a < qq->answers.count();a++){
                Answer* aa = (Answer*)&qq->answers.at(a);
                aa->job = ADD_;
                if(aa->text.count() > 0)setLangOfSingleElementTo(&aa->text.at(0),lang_id,ADD_);
                if(aa->explanation.count() > 0)setLangOfSingleElementTo(&aa->explanation.at(0),lang_id,ADD_);
            }
        }
    }
}
QList<Lang_Text> reOrderTextByLangId(QList<Lang_Text>* ltl,QList<languageType> languages){
    //qDebug() << "________________ txt Check! _________________-";
    QList<Lang_Text> txt1;
    for(int i = 0; i < languages.count();i++){
        if(languages.at(i).job == ADD_)continue;
        int id = languages.at(i).getLangId();
        int finalId = -1;
        for(int t = 0; t < ltl->count();t++){
            if(ltl->at(t).lang_id == id){
                finalId = t;
                break;
            }
        }

        Lang_Text nlt;
        if(finalId == -1){
           // qDebug() << "ICH WARS!!!" << id;
            nlt = Lang_Text(id," SAMPLE TEXT ");
            nlt.lang_id = id;
            nlt.job = ADD_;
        }
        else
            nlt = ltl->at(finalId);


        txt1.append(nlt);
    }
    // qDebug() << "________________________________";
    return txt1;
}

QFont getSTDFont()
{
    QFont f;
    f.setStretch(50);
    return f;
}
bool saveExampleFileTo(QString s){    

    if(!s.contains(".SQL")||!s.contains(".sql")){
        s.append(".sql");
    }
    QFile org;
    org.setFileName(":/examples/file_database.sql");
    org.open(QIODevice::ReadOnly);
    QFile ff;
    ff.setFileName(s);
    if(!QFile::exists(s)){
        if(!ff.open(QIODevice::ReadWrite))
        {
            return false;
        }
        else
        {
            ff.write(org.readAll());
            ff.close();

        }
    }
    else{
        org.close();
        return false;
    }
    return true;
}
SQLStructure::SQLStructure(){}
SQLStructure::SQLStructure(QString tableName,QStringList list)
{
    this->tableName = tableName;
    for(int i = 0; i < list.count();i++){
        if(i == 0)
            collum1 = list.at(i);
        if(i == 1)
            collum2 = list.at(i);
        if(i == 2)
            collum3 = list.at(i);
        if(i == 3)
            collum4 = list.at(i);
        if(i == 4)
            collum5 = list.at(i);

    }

}
SQLStructureContainer getDefaultSQLStructure(){
    SQLStructureContainer s;
    QStringList sl;
    //-----------lang----------
    sl<< "lang_id";sl<< "country_code";
    s.lang = SQLStructure("lang",sl);
    sl.clear();
    //-----------category------
    sl<< "category_id";
    s.category = SQLStructure("category",sl);
    sl.clear();
    //-----------question------
    sl<< "question_id";
    s.question = SQLStructure("question",sl);
    sl.clear();
    //-----------answer--------
    sl<< "answer_id";
    s.answer = SQLStructure("answer",sl);
    sl.clear();
    //-----------question_answer--------
    sl<< "question_id";sl<< "answer_id";sl<< "is_True";
    s.question_answer = SQLStructure("question_answer",sl);
    sl.clear();
    //-----------answer_lang--------
    sl<< "answer_id";sl<< "lang_id";sl<< "answer_text";
    s.answer_lang = SQLStructure("answer_lang",sl);
    sl.clear();
    //-----------question_lang--------
    sl<< "question_id";sl<< "lang_id";sl<< "question_text";sl<< "question_explanation";
    s.question_lang = SQLStructure("question_lang",sl);
    sl.clear();
    //-----------category_lang--------
    sl<< "category_id";sl<< "lang_id";sl<< "category_text";
    s.category_lang = SQLStructure("category_lang",sl);
    sl.clear();
    return s;
}

QStringList getSampleCSVRow(int lang_count){
    QStringList s;
    for(int i = 0; i < lang_count;i++){
        s.append("COUNTRYCODE");s.append("CATEGORY");
        s.append("QUESTION");
        s.append("ANSWER RIGHT");s.append("EXPLANATION");
        s.append("ANSWER WRONG");s.append("EXPLANATION");
        s.append("ANSWER WRONG");s.append("EXPLANATION");
        s.append("ANSWER WRONG");s.append("EXPLANATION");
        s.append("PLACEHOLDER");
    }
    return s;
}
QString getTextWithLangId(const QList<Lang_Text>* lt,int l_Id){
    for(int i = 0; i < lt->count();i++){
        if(lt->at(i).lang_id == l_Id)
            return lt->at(i).text;
    }
    return "Sample Text";
}
void checkStringForBadSymbols(const Lang_Text* l){
    Lang_Text* ll = (Lang_Text*)l;
    ll->text.replace("'","");

}
void checkForBadSymbols(QList<Category> *cat)
{
    for(int c = 0; c < cat->count();c++){
        Category* cc = (Category*)&cat->at(c);
        for(int h=0;h < cc->text.count();h++)checkStringForBadSymbols(&cc->text.at(h));
        for(int q = 0; q < cc->questions.count();q++){
            Question* qq = (Question*)&cc->questions.at(q);

            for(int h=0;h < qq->text.count();h++)checkStringForBadSymbols(&qq->text.at(h));
            for(int a = 0; a < qq->answers.count();a++){
                Answer* aa = (Answer*)&qq->answers.at(a);
                for(int h=0;h < aa->text.count();h++)checkStringForBadSymbols(&aa->text.at(h));
                for(int h=0;h < aa->explanation.count();h++)checkStringForBadSymbols(&aa->explanation.at(h));
            }
        }
    }
}




void setAllToAddMode(QList<Category> *cat)
{
    for(int c = 0; c < cat->count();c++){
        Category* cc = (Category*)&cat->at(c);
        cc->job = ADD_;

        for(int h=0;h < cc->text.count();h++)setLangOfSingleElementTo(&cc->text.at(h),cc->text.at(h).lang_id,ADD_);
        for(int q = 0; q < cc->questions.count();q++){
            Question* qq = (Question*)&cc->questions.at(q);
            qq->job = ADD_;
            for(int h=0;h < qq->text.count();h++)setLangOfSingleElementTo(&qq->text.at(h),qq->text.at(h).lang_id,ADD_);
            for(int a = 0; a < qq->answers.count();a++){
                Answer* aa = (Answer*)&qq->answers.at(a);
                aa->job = ADD_;
                for(int h=0;h < aa->text.count();h++)setLangOfSingleElementTo(&aa->text.at(h),aa->text.at(h).lang_id,ADD_);
                for(int h=0;h < aa->explanation.count();h++)setLangOfSingleElementTo(&aa->explanation.at(h),aa->explanation.at(h).lang_id,ADD_);
            }
        }
    }
}


