#ifndef BASE_H
#define BASE_H

#include <QObject>
#include <QFont>
#include <QFile>
enum CurrentEditType{CATEGORY,QUESTION,ANSWER,NOTHING_};
enum job_state{ADD_,EDIT,DELETE_,NOTHING,IDK_};



class SQLStructure{

public:
    SQLStructure();
    SQLStructure(QString tableName,QStringList list = QStringList());
    QString tableName;
    QString collum1;
    QString collum2;
    QString collum3;
    QString collum4;
    QString collum5;
};

class SQLStructureContainer{
public:
    SQLStructure lang;
    SQLStructure category_lang;
    SQLStructure question_lang;
    SQLStructure answer_lang;
    SQLStructure category;
    SQLStructure question;
    SQLStructure answer;
    SQLStructure question_answer;


};

class languageType{
    int lang_Id;
public:
    languageType(int id,QString langCode,QString langName="");
    job_state job;
    QString lang;
    int getLangId() const;
};
class Lang_Text{
public:
    job_state job;
    Lang_Text(int id = 0,QString txt = "",job_state js = NOTHING);
    int lang_id;//index von language type liste
    QString text;
};
class Question;
class Category{
    int category_id ;
public:
    Category(int id);
    job_state job;
    QList<Lang_Text> text;
    QList<Question> questions;
    void setCategoryId(int id);
    int getCategoryId() const;
    void addOneQuestion(Question q);
    void updateIds();
};
class Answer;
class Question{
    Category* parentCategory;
    int question_id;
    int category_id;

public:
    Question(int id ,Category* parent = Q_NULLPTR);
    job_state job;
    QList<Lang_Text> text;
    QList<Answer> answers;
    Category* getParent() const;//unsafe
    int  getQuestionid() const;
    int  getCategoryid() const;
    void setQuestionId(int id);
    void setCategoryId(int cId);
    void setParentAddress(Category* =Q_NULLPTR);
    void addOneAnswer(Answer a);
    void updateIds();
};
class Answer{
    Question* parentQuestion;
    int category_id;
    int question_id;
    int answer_id;
    bool isRight;
public:
    Answer(int answer_id, Question* parent);
    job_state job;
    QList<Lang_Text> text;
    QList<Lang_Text> explanation;
    int getAnswer_id () const;
    int getQuestionId() const;
    int getCategoryId() const;
    bool isCorrect() const;
    void setCorrect(bool b);
    void setAnswerId  (int id);
    void setQuestionId(int id);
    void setCategoryId(int id);

};
class UserDataBase{
public:
    QList<languageType> languages;
    QList<Category> categorys;
    void printAll();
};
void setAllToAddMode(QList<Category>* cat);
void updateLangOfCategoryTo(QList<Category>* cat,int lang_id);
void fixData(QList<Category>* cat,QList<languageType> languages);
void checkForBadSymbols(QList<Category> *cat);
QList<Lang_Text> reOrderTextByLangId(QList<Lang_Text>* ltl, QList<languageType> languages);
QFont getSTDFont();
QFont getRedMarkedFont();
SQLStructureContainer getDefaultSQLStructure();
bool saveExampleFileTo(QString s);
QStringList getSampleCSVRow(int lang_count);
QString getTextWithLangId(const QList<Lang_Text>* lt,int l_Id);
#endif // BASE_H
