#include "controller.h"
#include "mainform.h"
Controller::Controller(QObject *parent) : QObject(parent)
{
    m = new Modell  ();
    csv = new CSVManager;
    w = new MainForm(this);

    w->show();
    connect(this,SIGNAL(onDataBaseOpen(UserDataBase*)),w,SLOT(onNewDataBase(UserDataBase*)));
    connect(w,SIGNAL(saveData()),this,SLOT(onSaveDatabase()));
    connect(this,SIGNAL(onDataBaseClose()),w,SLOT(onDatabaseClose()));
    connect(w,SIGNAL(openCSVAt(QString,int)),csv,SLOT(openCSVFileAt(QString,int)));
    connect(w,SIGNAL(openMLCSVAt(QString,QList<int>)),csv,SLOT(openCSVFileAt(QString,QList<int>)));
    connect(w,SIGNAL(openAltCSVAt(QString,QList<int>)),csv,SLOT(openAlternativeCSVFileAt(QString,QList<int>)));
    connect(csv,SIGNAL(gainedNewData(UserDataBase)),this,SLOT(combineWithDatabase(UserDataBase)));
    connect(w,SIGNAL(exportDatabaseTo(QString)),m,SLOT(exportDataBaseAsCSV(QString)));
}
void Controller::onSaveDatabase(){
    m->saveChangesToDataBase();
    w->onDatabaseClose();
    w->onNewDataBase(m->getDatabaseReference());

}
void Controller::combineWithDatabase(UserDataBase d){
    UserDataBase* dbRef = w->getDatbaseRef();
    //qDebug() << "hello";
    dbRef->categorys.append(d.categorys);
    fixData(&dbRef->categorys,dbRef->languages);

    w->refreshView();
}
void Controller::openDatabaseAt(QString s){
    w->onDatabaseClose();
    m->closeDatabase();
    m->openDatabase(s);
    emit onDataBaseOpen(m->getDatabaseReference());

}
void Controller::closeDatabase(){
    m->closeDatabase();
    emit onDataBaseClose();
}
