#ifndef EDITWIDGET_H
#define EDITWIDGET_H
#include "base.h"
#include <QtWidgets>

class EditWidget : public QWidget
{
    Q_OBJECT
private:
    CurrentEditType mode;
    QList<Category>* cList;
    QList<Question>* qList;
    QList<Answer  >* aList;
    Category* ownerOfQList;
    Question* ownerOfAList;
    QListWidget* listView;
    QPushButton* hinzufuegenBtn;
    QPushButton* deleteBtn;
    QPushButton* editBtn;
    QPushButton* continueBtn;
    QLabel* infoLabel;
    EditWidget* parentEditWidget;
    bool iAmBlue;
    int curLang;
public:
    QList<Category>* getCList();
    QList<Question>* getQList();
    QList<Answer  >* getAList();
    void setParentEditWidget(EditWidget* nParent);
    bool getIsBlue();
    void setMode(CurrentEditType t);
    Category* getOwnerOfQList();
    Question *getOwnerOfAList();
    explicit EditWidget(CurrentEditType cET = NOTHING_,QWidget *parent = 0);

signals:
    void SelectedData(QList<Answer  >*,Question*);
    void SelectedData(QList<Question>*,Category*);
    void SelectedData(QList<Category>*);
    void SelectedToEdit(Category* c);
    void SelectedToEdit(Question* q);
    void SelectedToEdit(Answer*   a);

    void onNewData();
    void addTypeToList(CurrentEditType cET);
    void onDeletingStuff();
    void instantDeletedStuff();//

private slots:
    void onSelectAndContinue();
    void addAndEditNewElement();
    void renameDeleteBtn();
public slots:
    void setStdLang(int d);
    void resyncList();
    void cleanAllData();
    void selectionEdit();
    void selectionDelete();
    void turnOffSelectAble();
    void openAllData(QList<Category>*);
    void openAllData(QList<Question>*, Category* owner);
    void openAllData(QList<Answer>*  , Question* owner);
    void updateText();

};

#endif // EDITWIDGET_H
