#include "importwidget.h"

ImportWidget::ImportWidget(QWidget *parent) : QWidget(parent)
{

    this->setWindowTitle("Import a Single Language *.CSV File");
    cancelBtn = new QPushButton("Cancel");
    importBtn = new QPushButton("IMPORT!");
    chooseFileBtn = new QPushButton("Chose File");
    multipleLangButton = new QPushButton("multiple Languages");
    langText = new QLabel("Language:");
    fileText = new QLabel("File:");
    lang = new QComboBox();


    QGridLayout* layout = new QGridLayout();
    layout->addWidget(langText,1,0);
    layout->addWidget(lang,1,1);
    layout->addWidget(fileText,2,0);
    layout->addWidget(chooseFileBtn,2,1);
  //  layout->addWidget(multipleLangButton,4,1);
    layout->addWidget(cancelBtn,4,0);
    layout->addWidget(importBtn,4,2);
    layout->setRowStretch(2,10);
    this->setLayout(layout);

    connect(cancelBtn,SIGNAL(clicked(bool)),this,SLOT(onCloseBtn()));
    connect(importBtn,SIGNAL(clicked(bool)),this,SLOT(onConfirmBtn()));
    connect(chooseFileBtn,SIGNAL(clicked(bool)),this,SIGNAL(getFile()));
    //connect(multipleLangButton,SIGNAL(clicked(bool)),
}
void ImportWidget::closeEvent(QCloseEvent *event)
{
    emit this->aborted();
    event->accept();
}
void ImportWidget::setPath(QString s)
{
    path = s;
    checkForValidation();
}
void ImportWidget::checkForValidation(){
    importBtn->setEnabled(QFile::exists(path));
    qDebug() << "lal "<<path<< QFile::exists(path);
}
void ImportWidget::updateText()
{
    cancelBtn     = new QPushButton(tr("cancel"));
    importBtn     = new QPushButton(tr("IMPORT!"));
    chooseFileBtn = new QPushButton(tr("chose File"));

}
void ImportWidget::onCloseBtn(){
    this->close();
    emit this->aborted();
}
void ImportWidget::onConfirmBtn(){
    this->close();
    int lang_id = 1;
    if(lt.count() > 0){
        lang_id = lt.at(lang->currentIndex()).getLangId();
    }
    emit this->done(path,lang_id);
}
void ImportWidget::openImportWidget()
{
    path = "";
    checkForValidation();
    this->show();this->setFocus();
}

void ImportWidget::updateLanguageType(QList<languageType> nLT)
{
    lang->blockSignals(true);
    lang->clear();
    lt = nLT;
    for(int i = 0; i < lt.count();i++){
        lang->addItem(lt.at(i).lang);
    }
    lang->blockSignals(false);
}
