#ifndef IMPORTWIDGET_H
#define IMPORTWIDGET_H
#include "base.h"
#include <QtWidgets>
#include <QCloseEvent>
class ImportWidget : public QWidget
{
    Q_OBJECT

    QPushButton* cancelBtn;
    QPushButton* importBtn;
    QPushButton* chooseFileBtn;
    QPushButton* multipleLangButton;
    QLabel* langText;
    QLabel* fileText;
    QComboBox*   lang;
    QString path;
    QList<languageType> lt;

public:
    explicit ImportWidget(QWidget *parent = 0);

signals:
  void getFile();
  void done(QString,int);
  void aborted();
public slots:
  void setPath(QString);
  void updateText();
  void openImportWidget();
  void updateLanguageType(QList<languageType> nLT);
protected:
  void closeEvent(QCloseEvent *event);
protected slots:
  void onCloseBtn();
  void onConfirmBtn();
  void checkForValidation();
private slots:

};

#endif // IMPORTWIDGET_H
