#ifndef LANGEDITOR_H
#define LANGEDITOR_H
#include "base.h"
#include <QtWidgets>

class LangEditor : public QWidget
{
    Q_OBJECT
private:
    QList<languageType>* ltype;
    QListWidget* allLangs;
    QLineEdit*   nameEdit;
    QLineEdit*   langkuerzelEdit;
    QPushButton* editConfBtn;
    QPushButton* editAbortBtn;
    QPushButton* editBtn;
    QPushButton* deleteBtn ;
    QPushButton* addBtn;

    int getCurrentSelectionIndex();
    languageType* curTile;
    bool editMode;
public:
    explicit LangEditor(QWidget *parent = 0);
signals:
    void editFinished();
    void editAborted() ;
private slots:
    void onEditConfirmBtn();
    void onEditAbortBtn();
    void onEditBtn();
    void onSelectionChanged();
    void onDeleteBtn();
    void onAddBtn();

public slots:
    void newLangReference(QList<languageType>* q);
    void resyncList();
    void cleanAllData();
};

#endif // LANGEDITOR_H
