#include "mainform.h"
#include "controller.h"
#define VERSION "v2.6.2f4"
MainForm::MainForm(Controller* c,QWidget *parent)
    : QMainWindow(parent)
{
    contr = c;
    this->setContextMenuPolicy(Qt::PreventContextMenu);//desabled das Kontext Menü
    popUpEditor = new PopUpEditor;
    importWdgt  = new ImportWidget;
    altImportWdgt = new AltCSVImpWidgt;
    mlImportWidget = new MLIW;
    categoryEdit = new EditWidget(CATEGORY);
    questionEdit = new EditWidget(QUESTION);
    answerEdit   = new EditWidget(ANSWER);
    lEdit = new LangEditor;
    stdLangChooser  = new QComboBox();
    answerEdit->setParentEditWidget(questionEdit);//damit das auch durch Category  blau wird

    QToolButton* fileToolButton = new QToolButton();//ref
    fileToolButton->setText("FILE");
    fileToolButton->setPopupMode(QToolButton::InstantPopup);
    fileToolButton->setToolTip("Created by David Henkel");

    extrasBtn = new QToolButton;
    extrasBtn->setText("Extras");
    QAction *sqlGen = new QAction("Generate Example SQL File"   ,  this);
    QAction *genCSV = new QAction("Gen. Singale Language Example CSV File"   ,  this);
    QAction *genMLCSV = new QAction("Gen. Multi Language Example CSV File"   ,  this);
    extrasBtn->addAction(sqlGen);
    extrasBtn->addAction(genCSV);
    extrasBtn->addAction(genMLCSV);
    extrasBtn->setPopupMode(QToolButton::InstantPopup);
    settingsBtn = new QToolButton();
    settingsBtn->setText("Settings");
    settingsBtn->setPopupMode(QToolButton::InstantPopup);
    importBtn = new QToolButton();//ref
    importBtn->setText("Import");
    importBtn->setPopupMode(QToolButton::InstantPopup);
    exportBtn =  new QToolButton();//ref
    exportBtn->setText("Export");
    exportBtn->setPopupMode(QToolButton::InstantPopup);


    QAction* ac = new QAction("Import single Language CSV File",this);
    QAction* ac2 = new QAction("Import multi Lanugage  CSV File",this);
    QAction* ac3 = new QAction("Import CSV File from Erasmus+ Quiz App",this);
    importBtn->addAction(ac);
    importBtn->addAction(ac2);
    importBtn->addAction(ac3);
    examplePath = new QFileDialog();
    examplePath->setFileMode(QFileDialog::AnyFile);
    examplePath->setAcceptMode(QFileDialog::AcceptSave);
    examplePath->setNameFilter(tr("CSV (*.csv *.CSV)"));
    examplePathMultiL = new QFileDialog();
    examplePathMultiL->setFileMode(QFileDialog::AnyFile);
    examplePathMultiL->setAcceptMode(QFileDialog::AcceptSave);
    examplePathMultiL->setNameFilter(tr("CSV (*.csv *.CSV)"));
    examplePathMultiL->setFileMode(QFileDialog::AnyFile);
    examplePathMultiL->setAcceptMode(QFileDialog::AcceptSave);

    existingFile = new QFileDialog();
    existingFile->setFileMode(QFileDialog::ExistingFile);
    newFile = new QFileDialog();
    newFile->setFileMode(QFileDialog::AnyFile);
    newFile->setAcceptMode(QFileDialog::AcceptSave);
    examplePathSQL = new QFileDialog();
    examplePathSQL->setFileMode(QFileDialog::AnyFile);
    examplePathSQL->setAcceptMode(QFileDialog::AcceptSave);
    csvImporter = new QFileDialog();
    csvImporter->setFileMode(QFileDialog::ExistingFile);
    csvImporter->setNameFilter(tr("CSV (*.csv *.CSV)"));

    exportPath = new QFileDialog();
    exportPath->setFileMode(QFileDialog::AnyFile);
    exportPath->setAcceptMode(QFileDialog::AcceptSave);
    exportPath->setNameFilter(tr("CSV (*.csv *.CSV)"));

    QAction *openF  = new QAction("Open File",                  this);
    QAction *newF   = new QAction("New File",                   this);
    QAction *saveF  = new QAction("Save",                       this);
    QAction *close  = new QAction("Close File Without Saving",  this);

    QAction *expDataAsCSV = new QAction("Export Database as CSV File"        ,  this);
    QAction *changeLang  = new QAction("configure",  this);
    QAction *appLanguageBtn  = new QAction("configure",  this);
    speachButton = new QToolButton();
    speachButton->setText("Language");
    speachButton->setPopupMode(QToolButton::InstantPopup);
    speachButton->addAction(changeLang);
    settingsBtn->addAction(appLanguageBtn);
    fileToolButton->addAction(newF );
    fileToolButton->addAction(openF);
    fileToolButton->addAction(saveF);
    fileToolButton->addAction(close);

    exportBtn->addAction(expDataAsCSV);
    QToolBar* toolbar = new QToolBar();
    toolbar->addWidget(fileToolButton);
    toolbar->addWidget(speachButton);
    toolbar->addWidget(importBtn);
    toolbar->addWidget(exportBtn);
    toolbar->addWidget(extrasBtn);
   // toolbar->addWidget(settingsBtn);
    toolbar->addWidget(stdLangChooser);
    this->addToolBar(toolbar);



    //////TESTING

    widgetContainer = new QWidget();//spacerWidget

    QGridLayout* layout = new QGridLayout();
    layout->addWidget(categoryEdit,0,0);
    layout->addWidget(questionEdit,0,1);
    layout->addWidget(answerEdit,1,0,1,2);
    widgetContainer->setLayout(layout);
    this->setCentralWidget(widgetContainer);
    //////END TESTING
    updateText();
    //connects und so JO
    connect(popUpEditor,SIGNAL(editFinished()),this,SLOT(unblockView()));
    connect(popUpEditor,SIGNAL(editAborted ()),this,SLOT(unblockView()));
    connect(importWdgt,SIGNAL(aborted())    ,this       ,SLOT(unblockView()));
    connect(importWdgt,SIGNAL(done(QString,int)),this       ,SLOT(unblockView()));
    connect(importWdgt,SIGNAL(done(QString,int)),this    ,SIGNAL(openCSVAt(QString,int)));
    connect(importWdgt,SIGNAL(getFile())    ,csvImporter,SLOT(show()));

    connect(altImportWdgt,SIGNAL(onWindowClose())    ,this       ,SLOT(unblockView()));
    connect(altImportWdgt,SIGNAL(import(QString,QList<int>)),this,SIGNAL(openAltCSVAt(QString,QList<int>)));
    connect(mlImportWidget,SIGNAL(onWindowClose())    ,this       ,SLOT(unblockView()));
    connect(mlImportWidget,SIGNAL(import(QString,QList<int>)),this,SIGNAL(openMLCSVAt(QString,QList<int>)));

    connect(csvImporter,SIGNAL(fileSelected(QString)),importWdgt,SLOT(setPath(QString)));
    connect(expDataAsCSV,SIGNAL(triggered(bool)),exportPath,SLOT(show()));

    connect(exportPath,SIGNAL(fileSelected(QString)),this,SIGNAL(exportDatabaseTo(QString)));
    connect(saveF,SIGNAL(triggered(bool)),this,SLOT(onSavingData()));
    connect(openF,SIGNAL(triggered(bool)),existingFile,SLOT(show()));
    connect(newF ,SIGNAL(triggered(bool)),newFile     ,SLOT(show()));
    connect(ac   ,SIGNAL(triggered(bool)),importWdgt  ,SLOT(openImportWidget()));
    connect(ac   ,SIGNAL(triggered(bool)),this        ,SLOT(blockView()));
    connect(ac2   ,SIGNAL(triggered(bool)),mlImportWidget  ,SLOT(openImportWidget()));
    connect(ac2   ,SIGNAL(triggered(bool)),this        ,SLOT(blockView()));
    connect(ac3   ,SIGNAL(triggered(bool)),altImportWdgt  ,SLOT(openAltImportWidget()));
    connect(ac3   ,SIGNAL(triggered(bool)),this        ,SLOT(blockView()));
    connect(examplePath,SIGNAL(fileSelected(QString)),this,SLOT(onExamplePath(QString)));//-------
    connect(genCSV,SIGNAL(triggered(bool)),examplePath,SLOT(open()));
    connect(examplePathMultiL,SIGNAL(fileSelected(QString)),this,SLOT(onMultiLangExamplePath(QString)));//-------
    connect(genMLCSV,SIGNAL(triggered(bool)),examplePathMultiL,SLOT(open()));
    connect(existingFile,SIGNAL(fileSelected(QString)),contr,SLOT(openDatabaseAt(QString)));
    connect(newFile     ,SIGNAL(fileSelected(QString)),contr,SLOT(openDatabaseAt(QString)));
    connect(close       ,SIGNAL(triggered   (       )),contr,SLOT(closeDatabase ()));
    connect(categoryEdit,SIGNAL(SelectedData(QList<Question>*,Category*)),questionEdit,SLOT(openAllData(QList<Question>*,Category*)));
    connect(questionEdit,SIGNAL(SelectedData(QList<Answer>*,Question*)),answerEdit,SLOT(openAllData(QList<Answer>*,Question*)));
    connect(categoryEdit,SIGNAL(SelectedToEdit(Category*))  ,popUpEditor,SLOT(editCategory(Category*)));
    connect(questionEdit,SIGNAL(SelectedToEdit(Question*))  ,popUpEditor,SLOT(editQuestion(Question*)));
    connect(answerEdit  ,SIGNAL(SelectedToEdit(Answer*  ))  ,popUpEditor,SLOT(editAnswer  (Answer  *)));
    connect(categoryEdit,SIGNAL(onDeletingStuff()),questionEdit,SLOT(resyncList()));//if gets blue
    connect(categoryEdit,SIGNAL(onDeletingStuff()),answerEdit  ,SLOT(resyncList()));//then make all
    connect(questionEdit,SIGNAL(onDeletingStuff()),answerEdit  ,SLOT(resyncList()));//blue!!
    connect(categoryEdit,SIGNAL(onDeletingStuff()),popUpEditor,SLOT(close()));
    connect(categoryEdit,SIGNAL(onDeletingStuff()),popUpEditor,SLOT(close()));
    connect(questionEdit,SIGNAL(onDeletingStuff()),popUpEditor,SLOT(close()));//close on edit
    connect(categoryEdit,SIGNAL(instantDeletedStuff()),questionEdit,SLOT(cleanAllData()));//if Element gets deleted
    connect(categoryEdit,SIGNAL(instantDeletedStuff()),answerEdit  ,SLOT(cleanAllData()));//And was marked as add
    connect(questionEdit,SIGNAL(instantDeletedStuff()),answerEdit  ,SLOT(cleanAllData()));//then dont display child elements
    connect(popUpEditor ,SIGNAL(editFinished()),            this        ,SLOT(onTextEdited()));
    connect(categoryEdit,SIGNAL(addTypeToList(CurrentEditType)),this,SLOT(addAndEditNewElement(CurrentEditType)));
    connect(questionEdit,SIGNAL(addTypeToList(CurrentEditType)),this,SLOT(addAndEditNewElement(CurrentEditType)));
    connect(answerEdit  ,SIGNAL(addTypeToList(CurrentEditType)),this,SLOT(addAndEditNewElement(CurrentEditType)));
    connect(questionEdit,SIGNAL(onNewData()),answerEdit,SLOT(cleanAllData()));
    connect(changeLang  ,SIGNAL(triggered()),lEdit     ,SLOT(show()));
    connect(stdLangChooser,SIGNAL(currentIndexChanged(int)),this     ,SLOT(selectionChangedStdLangCBox(int)));
    connect(sqlGen,SIGNAL(triggered(bool))              ,examplePathSQL,SLOT(show()));
    connect(examplePathSQL,SIGNAL(fileSelected(QString)),this,SLOT(onSQLExamplePath(QString)));
    connect(this,       SIGNAL(newLangIndexChosen(int)),categoryEdit,SLOT(setStdLang(int)));
    connect(this,       SIGNAL(newLangIndexChosen(int)),questionEdit,SLOT(setStdLang(int)));
    connect(this,       SIGNAL(newLangIndexChosen(int)),answerEdit  ,SLOT(setStdLang(int)));
    connect(this,       SIGNAL(newLangIndexChosen(int)),popUpEditor ,SLOT(setCurLangId(int)));

    blockView();
    last = 0;
}

UserDataBase *MainForm::getDatbaseRef()
{
    return this->dbSelf;
}
void MainForm::onExamplePath(QString q){
    if(!q.contains(".csv")){
        q.append(".csv");
    }
    QFile org;
    org.setFileName(":/examples/file.csv");
    org.open(QIODevice::ReadOnly);
    QFile c;
    c.setFileName(q);
    c.open(QIODevice::ReadWrite);
    c.write(org.readAll());
    c.close(); org.close();
}
void MainForm::onMultiLangExamplePath(QString q){
    if(!q.contains(".csv")||!q.contains(".CSV")){
        q.append(".csv");
    }
    QFile org;
    org.setFileName(":/examples/file_multiLang.csv");
    org.open(QIODevice::ReadOnly);
    QFile c;
    c.setFileName(q);
    c.open(QIODevice::ReadWrite);
    c.write(org.readAll());
    c.close(); org.close();
}
void MainForm::onSQLExamplePath(QString s){
    saveExampleFileTo(s);
}
void MainForm::updateStdLangCBox(){
    stdLangChooser->blockSignals(true);
    stdLangChooser->clear();
    if(dbSelf == Q_NULLPTR)return;
    for(int i = 0; i < dbSelf->languages.count();i++){
        //jojojojo
        if(dbSelf->languages.at(i).job != ADD_){
            QVariant oo (i);
            stdLangChooser->addItem(dbSelf->languages.at(i).lang,oo);//in QVariant wird der Listen index geSaved!
        }
    }
    stdLangChooser->blockSignals(false);
}
void MainForm::selectionChangedStdLangCBox(int ind){
    if(dbSelf == Q_NULLPTR || ind >= stdLangChooser->count())return;
    int langIndex = stdLangChooser->itemData(ind).toInt();
    emit newLangIndexChosen(langIndex);
}

void MainForm::addAndEditNewElement(CurrentEditType c){
    if(c == ANSWER)
    {
        Question* q = answerEdit->getOwnerOfAList();
        q->addOneAnswer(Answer(-1,q));
        Answer * cc = (Answer*)&answerEdit->getAList()->last();
        cc->job = ADD_;
        popUpEditor->editAnswer(cc);
    }
    if(c == QUESTION)
    {
        Category* cat = questionEdit->getOwnerOfQList();
        cat->addOneQuestion(Question(-1,cat));
        Question * cc = (Question*)&questionEdit->getQList()->last();
        cc->job = ADD_;
        popUpEditor->editQuestion(cc);
    }
    if(c == CATEGORY)
    {
        categoryEdit->getCList()->append(Category(-1));

        Category * cc = (Category*)&categoryEdit->getCList()->last();
        cc->job = ADD_;
        popUpEditor->editCategory(cc);
    }
}
void MainForm::onTextEdited(){
    questionEdit->resyncList();
    categoryEdit->resyncList();
    answerEdit->  resyncList();
}
void MainForm::onSavingData(){
    emit this->saveData();
}
void MainForm::refreshView(){
    questionEdit->resyncList();
    categoryEdit->resyncList();
    answerEdit->  resyncList();
}
void MainForm::onNewDataBase(UserDataBase* dbs){
    if(dbs == Q_NULLPTR)return;

    dbSelf = dbs;
    lEdit->newLangReference((QList<languageType>*)&dbs->languages);

    categoryEdit->openAllData((QList<Category>*)&dbSelf->categorys);
    popUpEditor->updateLanguges(dbSelf->languages);
    unblockView();
    updateStdLangCBox();
    if(dbSelf->languages.count() == 0)
        categoryEdit->setEnabled(false);
    else
        categoryEdit->setEnabled(true);
    newLangIndexChosen(last);
    importWdgt->updateLanguageType(dbs->languages);
    mlImportWidget->updateLang(dbs->languages);
    altImportWdgt->updateLang(dbs->languages);
}
void MainForm::onDatabaseClose(){
    dbSelf = Q_NULLPTR;
    categoryEdit->cleanAllData();
    questionEdit->cleanAllData();
    answerEdit->cleanAllData();
    popUpEditor->cleanAllData();
    lEdit->cleanAllData();
    lEdit->hide();
    blockView();
}
void MainForm::blockView(){
    widgetContainer->setEnabled(false);
    speachButton->setEnabled(false);
    importBtn->setEnabled(false);
    exportBtn->setEnabled(false);
}
void MainForm::unblockView(){
    widgetContainer->setEnabled(true);
    speachButton->setEnabled(true);
    importBtn->setEnabled(true);
    exportBtn->setEnabled(true);

}
void MainForm::updateText(){
    this->setWindowTitle(tr("Erasmus+ Database Editor "VERSION));
}
MainForm::~MainForm()
{

}
