#ifndef MODELL_H
#define MODELL_H

#include <QObject>
#include "base.h"
#include <QSqlDatabase>
#include <QSqlQuery>
class Modell : public QObject
{
    Q_OBJECT
private:
    SQLStructureContainer structure;
    UserDataBase dbSelf;
    QSqlQuery getQuery();
    QSqlDatabase database;
    QString path;
    void addLanguageTypeFromDatabase    (languageType* lt);
    void addCategoryToDatabase          (Category* c );
    void addQuestionToDatabase          (Question* q );
    void addAnswerToDatabase            (Answer  * a );
    void renameCategoryFromDatabase     (Category* c );
    void renameQuestionFromDatabase     (Question* c );
    void renameAnswerFromDatabase       (Answer  * a );
    void renameLanguageTypeFromDatabase (languageType* lt);
    void deleteLanguageFromDataBase     (languageType* lt);
    void deleteCategoryFromDataBase     (Category* c );
    void deleteQuestionFromDataBase     (Question* c );
    void deleteAnswerFromDataBase       (Answer  * a );
    void removeAllTextFromCategory      (int languageId);
    void removeAllTextFromQuestion      (int languageId);
    void removeAllTextFromAnswer        (int languageId);
public:
    explicit Modell(QObject *parent = 0);
    bool isOpen();
    UserDataBase* getDatabaseReference();
signals:
    void dataBaseOpened();
    void dataBaseClosed();

private slots:
    void fillDataBaseWithStdLangs();
public slots:
    void exportDataBaseAsCSV(QString path);
    void createDataBase();
    void extractDataFromDatabase();
    void saveChangesToDataBase();
    void sendCategorys();
    void sendQuestions();
    void sendAnswersOf(int question_id);
    void openDatabase(QString path);
    void closeDatabase();
};

#endif // MODELL_H
