#ifndef MULTILANGIMPORTWIDGET_H
#define MULTILANGIMPORTWIDGET_H
#include "base.h"
#include <QtWidgets>

class MultiLangImportWidget : public QWidget
{
    Q_OBJECT
protected:
    QPushButton* abortBtn;
    QPushButton* importBtn;
    QPushButton* selectFileBtn;
    QSlider*     langCountSlider;
    QLabel*      sliderDescr;
    QLabel*      filePathDescr;
    QLabel*      infoTxt;
    QScrollArea* scrollArea;
    QWidget*     wContainer;
    QFileDialog* fileD;
    QString filePath;
    QList<languageType> langList;
    QList<QComboBox*>   comboList;
    QList<QLabel*>      labelList;
    bool isValidPath();
    void closeEvent(QCloseEvent *event);

public:
    explicit MultiLangImportWidget(QWidget *parent = 0);

signals:
    void openFileDialog();
    void import(QString,QList<int>);
    void onWindowClose();
public slots:
    void updateText();
    void updateLang(QList<languageType> ll);
    void openImportWidget(QList<languageType> ll);
    void abort();
    void onImportBtn();
    void openImportWidget();
private slots:




protected slots:
    void updateComboBox(QComboBox *cBox);
    void onSliderMoved();
    void syncComboBoxes();
    void checkIfImportable();
    void onNewPath(QString q);

};
typedef MultiLangImportWidget MLIW;

#endif // MULTILANGIMPORTWIDGET_H
