#ifndef POPUPEDITOR_H
#define POPUPEDITOR_H
#include <base.h>
#include <QtWidgets>

class PopUpEditor : public QWidget
{
    Q_OBJECT
private:
    QList<languageType> languages;
    QList<Lang_Text> text_One;
    QList<Lang_Text> text_Two;
    QList<Lang_Text> text_Three;
    QLabel* sprache;
    QComboBox* langChooser;
    QCheckBox* isCorrect;
    QLabel* dTxt1;
    QLabel* dTxt2;
    QLabel* dTxt3;
    QLineEdit* textOneEdit;
    QLineEdit* textTwoEdit;
    QLineEdit* textThreeEdit;
    QPushButton* accept;
    QPushButton* abort;
    Category* cat;
    Question* q;
    Answer* a;
    CurrentEditType currentJob;
    QList<Lang_Text> reOrderTextByLangId(QList<Lang_Text>* ltl);
    void desableAll();
public:
    explicit PopUpEditor(QWidget *parent = 0);

signals:
    void editFinished();
    void editAborted();
private slots:
    void onEditFinished();
    void onEditAborted ();
    void langIndexChanged ();
    void text1EditFinished();
    void text2EditFinished();
    void CheckBoxEditFinished();
    void text3EditFinished();
public slots:
    void editCategory   (Category* c);
    void editQuestion   (Question* q);
    void editAnswer     (Answer*   a);
    void updateLanguges (QList<languageType>);
    void setCurLangId(int);
    void updateText  ();
    void cleanAllData();
};

#endif // POPUPEDITOR_H
